import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

class tlp 
 {
  public static void main(String args[])
   {
    Environnement e=new Environnement();
   }
 }

public class tlpcql extends Applet
 {
  public void paint(Graphics g)
   {
    Environnement e=new Environnement();
   }
 }

class Environnement implements ActionListener
 {
  String r;
  Gci g;
  Frame f=new Frame("CQL");
  Button reset=new Button("Mise sous tension");
  Button status=new Button("Etat de la carte");
  Button hors_tension=new Button("Mise hors tension");
  Gestionfenetre gf=new Gestionfenetre();
  TextArea t=new TextArea("",5,80);
  Label lpresent=new Label("CQL PRESENT Nom d'utilisateur");
  TextField tnom=new TextField("",10);
  Label lpass=new Label("Mot de passe");
  TextField tpass=new TextField("",10);
  Button valider=new Button("Valider");
  Button annuler=new Button("Annuler");
  Panel p1=new Panel(),p2=new Panel(),p3=new Panel();
  Environnement()
  {
   f.setLayout(new BorderLayout());
   p1.setLayout(new FlowLayout());
   p1.add(reset);
   p1.add(status);
   p1.add(hors_tension);
   p1.add(t);
   p2.setLayout(new FlowLayout());
   p2.add(lpresent);
   p2.add(tnom);
   p2.add(lpass);
   p2.add(tpass);
   p3.setLayout(new FlowLayout());
   p3.add(valider);
   p3.add(annuler);
   f.add(p1,"North");
   f.add(p2,"Center");
   f.add(p3,"South");
   f.pack();
   f.show();
   f.addWindowListener(gf);
   reset.addActionListener(this);
   status.addActionListener(this);
   hors_tension.addActionListener(this);
   tnom.addActionListener(this);
   tpass.addActionListener(this);
   valider.addActionListener(this);
   annuler.addActionListener(this);
  }

 void maj_res()
  {
   t.replaceRange("",0,(t.getText()).length());
   t.insert(r,0);
  }

 public void actionPerformed(ActionEvent e)
   {
    Object o=e.getSource();

    if(o==reset)
      {
       Gci g=new Gci();
       r=g.ordre_reset();
       maj_res();
       return;
      }
    if(o==status)
      {
       Cql g=new Cql();
       r=g.ordre_cql_status();
       maj_res();
       return;
      }
    if(o==hors_tension)
      {
       Gci g=new Gci();
       r=g.ordre_hors_tension();
       maj_res();
       return;
      }
    if(o==annuler)
      {
       tnom.setText("");
       tpass.setText("");
       return;
      }
    if(o==valider)      
      {
       Cql g=new Cql();
       r=g.ordre_cql_present(tnom.getText(),tpass.getText());
       maj_res();
       tnom.setText("");
       tpass.setText("");
       return;
      }
   }
 }

class Gestionfenetre extends WindowAdapter
 {
  public void windowClosing(WindowEvent e)
   {
    System.exit(0);
   }
 }

class Gci extends Thread
 {
  String r;
  byte b[];

  String ordre_entrant(int cla,int ins,int a1,int a2,int ln,byte data[])
   {
    int n=ln+6,i;
    b=new byte[n];
    b[0]=(byte)0xda;
    b[1]=(byte)cla;
    b[2]=(byte)ins;
    b[3]=(byte)a1;
    b[4]=(byte)a2;
    b[5]=(byte)ln;
    for(i=0;i<ln;i++) b[i+6]=data[i];
    return emission();
   }

  String ordre_sortant(int cla,int ins,int a1,int a2,int ln)
   {
    b=new byte[6];
    b[0]=(byte)0xdb;
    b[1]=(byte)cla;
    b[2]=(byte)ins;
    b[3]=(byte)a1;
    b[4]=(byte)a2;
    b[5]=(byte)ln;
    return emission();
   }

  String ordre_reset()
   {
    b=new byte[4];
    b[0]=0x6e;
    b[1]=0;
    b[2]=0;
    b[3]=0;
    return emission();
   }

  String ordre_hors_tension()
   {
    b=new byte[1];
    b[0]=0x4d;
    return emission();
   }

  private String emission()
   {
    int i;

    i=0;
    start();
    do {
        try{
            sleep(100);
            i++;
           }catch(InterruptedException e){}
       }while(isAlive() && i<30);
    if(isAlive())
      {
       stop();
       r="timeout, verifiez si tlp224 est actif";
      }
    return r;
   }

  public void run()
  {
    attendre_sema();
    try {
         FileOutputStream sortie=new FileOutputStream("cardin");
         sortie.write(b);
         sortie.close();
        }catch(IOException e)
              {
               System.out.println("Impossible de creer cardin");
               System.exit(1);
              }
    try {
         FileOutputStream sema=new FileOutputStream("sema");
         sema.write(1);
         sema.close();
        }catch(IOException e)
              {
               System.out.println("Impossible de creer le fichier sema");
               System.exit(1);
              }
    attendre_sema();
    try {

         FileInputStream f=new FileInputStream("cardout");
         byte buffer[]=new byte[f.available()];
         f.read(buffer);
         r=hexa(buffer);
         f.close();
        } catch(FileNotFoundException e)
              {
               r="Fichier cardout non trouve";
              }
          catch(IOException e)
              {
               r="Erreur de lecture";
              }
  }

 private String hexa(byte b[])
  {
   StringBuffer t=new StringBuffer(512);
   int i;

   for(i=0;i<b.length;i++)
       {
        t.append(cvbyte(b[i]));
        t.append(' ');
       }
   return new String(t);
  }

 private String cvbyte(byte b)
  {
   StringBuffer t=new StringBuffer(2);

   t.append(cvnibble((byte)(((b>>4)&0x0f))));
   t.append(cvnibble((byte)(b&0x0f)));
   return new String(t);
  }

 private char cvnibble(byte b)
  {
   String s="0123456789ABCDEF";

   return s.charAt(b);
  }

 private void attendre_sema()
  {
    boolean b=true;

    do {
        try {
             b=true;

             FileInputStream f=new FileInputStream("sema");
             f.close();
            }catch(FileNotFoundException e)
                  {
                   b=false;
                  }
              catch(IOException e) {}
        if(b) try{
                  sleep(100);
                 }catch(InterruptedException e) {}
       }while(b);

  }
 }

class Cql extends Gci
 {
  byte data[];

  String ordre_cql_present(String nom,String password)
   {
    int position;
    int n=nom.length()+password.length()+2;
    data=new byte[n];
    position=ajout_chaine(0,nom);
    position=ajout_chaine(position,password);
    return ordre_entrant(0,(int)'P',0,0,n,data);
   }

  String ordre_cql_status()
   {
    return ordre_sortant(0,0x24,0,0,14);
   }

  private int ajout_chaine(int n,String s)
   {
    int i,p;

    p=n;
    data[p]=(byte)(s.length());
    p++;
    for(i=0;i<s.length();i++)
       {
        data[p]=(byte)(s.charAt(i));
        p++;
       }
    return p;
   }
 }
